/*
 * Sonar, entreprise quality control tool.
 * Copyright (C) 2007-2008 Hortis-GRC SA
 * mailto:be_agile HAT hortis DOT ch
 *
 * Sonar is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * Sonar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sonar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package org.sonar.application;

import org.apache.commons.configuration.Configuration;
import org.apache.commons.configuration.ConfigurationException;
import org.apache.commons.configuration.PropertiesConfiguration;

public class StartServer {
  private static final int DEFAULT_WEB_PORT = 9000;
  private static final String DEFAULT_WEB_CONTEXT = "/";

  public static void main(String[] args) throws Exception {
    configureLogback();

    Configuration configuration = getCoreConfiguration();
    int port = configuration.getInt("sonar.web.port", DEFAULT_WEB_PORT);
    String context = configuration.getString("sonar.web.context", DEFAULT_WEB_CONTEXT);
    JettyEmbedder jetty = new JettyEmbedder(port, context, StartServer.class.getResource("/jetty.xml"));
    jetty.start();
    Thread.currentThread().join();
  }

  private static Configuration getCoreConfiguration() throws ConfigurationException {
      return new PropertiesConfiguration(StartServer.class.getResource("/sonar.properties"));
  }

  private static void configureLogback() {
    System.setProperty("logback.ContextSelector", "JNDI");
  }
}